//Support_Impact_Damage by BluetoothBoy
//Usage instructions:

//Add "playerDamage = X;" to vehicle datablock for the minimum amount of health taken away upon impact (impact damage takes place at a speed of 25 or greater). Default = 5. Player(s) will die upon impact with a speed of 75 or greater.
package ImpactDamage
{
//Function for toggling damage.
function servercmdimpactdamage(%c)
{
	if(%c.isAdmin || %c.isSuperAdmin || %c.isHost)
	{
		if($toggled)
		{
			%c.chatmessage("\c3Impact damage \c0off!");
			$toggled = false;
		}
		else if(!$toggled)
		{
			%c.chatmessage("\c3Impact damage \c2on!");
			$toggled = true;
		}
	}
	else
	{
		%c.chatmessage("\c3You need to be admin to toggle impact damage.");
	}
}
//Add support.
function applyPlayerDamage(%obj, %player, %dmg)
{
	if((%player.getDamageLevel() + %dmg) - %player.getDataBlock().maxDamage < 0)
	{ 
		%player.applyDamage(%dmg);
	}
	else{
		%player.kill();
	}
}
function collided(%this, %obj, %col, %pos, %speed)
{
	if($toggled)
	{
		if(%speed >= 25 && %speed < 75)
		{
			if(%obj.getDataBlock().playerDamage)
			{
				for(%i = 0; %i < %obj.getDataBlock().numMountPoints; %i++)
				{
					if(%obj.getMountedObject(%i) != 0 && %obj.getMountedObject(%i).getDataBlock().rideable == false)
					{
						echo(%speed);
						%currentPlayer = %obj.getMountedObject(%i);
						applyPlayerDamage(%obj, %currentPlayer, %obj.getDataBlock().playerDamage*(%speed/25));						
					}
					else if(%obj.getMountedObject(%i) != 0 && %obj.getMountedObject(%i).getDataBlock().rideable == true && %obj.getMountedObject(%i2).getMountedObject(0) != 0)
					{
						%currentPlayer = %obj.getMountedObject(%i).getMountedObject(0);
						applyPlayerDamage(%obj, %currentPlayer, %obj.getDataBlock().playerDamage*(%speed/25));
					}
				}
			}
			else
			{
				for(%i1 = 0; %i1 < %obj.getDataBlock().numMountPoints; %i1++)
				{
					if(%obj.getMountedObject(%i1) != 0 && %obj.getMountedObject(%i).getDataBlock().rideable == false)
					{
						echo(%speed);
						%currentPlayer = %obj.getMountedObject(%i1);
						applyPlayerDamage(%obj, %currentPlayer, 5*(%speed/25));
					}
					else if(%obj.getMountedObject(%i1) != 0 && %obj.getMountedObject(%i1).getDataBlock().rideable == true && %obj.getMountedObject(%i2).getMountedObject(0) != 0)
					{
						%currentPlayer = %obj.getMountedObject(%i1).getMountedObject(0);
						applyPlayerDamage(%obj, %currentPlayer, 5*(%speed/25));
					}
				}
			}
		}
		else if(%speed >= 75)
		{
			for(%i2 = 0; %i2 < %obj.getDataBlock().numMountPoints; %i2++)
			{
				if(%obj.getMountedObject(%i2) != 0 && %obj.getMountedObject(%i).getDataBlock().rideable == false)
				{
					%currentPlayer = %obj.getMountedObject(%i2);
					%currentPlayer.kill();		
				}
				else if(%obj.getMountedObject(%i2) != 0 && %obj.getMountedObject(%i2).getDataBlock().rideable == true && %obj.getMountedObject(%i2).getMountedObject(0) != 0)
				{
					%currentPlayer = %obj.getMountedObject(%i2).getMountedObject(0);
					%currentPlayer.kill();
				}
			}
		}
	}
}

function WheeledVehicleData::onImpact(%this, %obj, %col, %pos, %speed)
{
	collided(%this, %obj, %col, %pos, %speed);
}
function FlyingVehicleData::onImpact(%this, %obj, %col, %pos, %speed)
{
	collided(%this, %obj, %col, %pos, %speed);
}
};
activatePackage(ImpactDamage);